/*
 * $Id: biditext.c,v 1.1.1.1 2001/09/13 12:42:16 mulix Exp $
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

#include <r2llib.h>

#include "hook_into_x.h"
#include "common.h"

/* pointers into X functions */ 
x_funcs_t x_funcs;

int
XDrawString(
    register Display *dpy,
    Drawable d,
    GC gc,
    int x,
    int y,
    _Xconst char *string,
    int length)
{   
     char *draw_string;
     int rc;
     
     if (length <= 0)
	  return 0;
     
     /* multi threading protection */
     XLockDisplay(dpy);
     
     draw_string = do_biditext8(dpy, gc, (char*)string, length);
   
     if (!draw_string)
	  draw_string = (char*)string;
     
     rc =  (*x_funcs.XDrawString)(dpy, d, gc, x, y, draw_string, length);
     
     XUnlockDisplay(dpy);
     
     return rc;
}

int
XDrawImageString(
    register Display *dpy,
    Drawable d,
    GC gc,
    int x,
    int y,
    _Xconst char *string,
    int length)
{   
     char *draw_string;
     int rc;

     if (length <= 0)
	  return 0;
     
     XLockDisplay(dpy);

     draw_string = do_biditext8(dpy, gc, (char*)string, length);

     if (!draw_string)
	 draw_string = (char*)string;

     rc = (*x_funcs.XDrawImageString)(dpy, d, gc, x, y, draw_string, length);
    
     XUnlockDisplay(dpy);

     return rc;
}

int
XDrawString16(
    register Display *dpy,
    Drawable d,
    GC gc,
    int x,
    int y,
    _Xconst XChar2b *string,
    int length)
{   
     XChar2b *draw_string;
     int rc;

     if (length <= 0)
	  return 0;
     
     XLockDisplay(dpy);
     
     draw_string = do_biditext16(dpy, gc, (XChar2b*)string, length);

     if (!draw_string)
	  draw_string = (XChar2b*) string;

     rc = (*x_funcs.XDrawString16)(dpy, d, gc, x, y, draw_string, length);
    
     XUnlockDisplay(dpy);

     return rc;
}


