/*
 * $Id: hook_into_x.c,v 1.1.1.1 2001/09/13 12:42:16 mulix Exp $
 */
#include <dlfcn.h>
#include <stdio.h>
#include <stdlib.h>

#include "hook_into_x.h"

void
biditext_hook_into_x(x_funcs_t* funcs)
{
     /* code hooked from emil's refreshd */
     void* xLibHandle;
     const char* errMsg = "No Error";
     
     xLibHandle = dlopen("libX11.so",RTLD_LAZY);
     if (xLibHandle == NULL) {
	  errMsg = dlerror();
	  goto err_dlopen_xlib;
     }

     funcs->XDrawString = (XDrawStringPtrType)dlsym(xLibHandle,"XDrawString");
     if (funcs->XDrawString == NULL) {
	  errMsg = dlerror();
	  goto err_dlsym;
     }
     
     funcs->XDrawImageString = (XDrawStringPtrType)dlsym(xLibHandle,"XDrawImageString");
     if (funcs->XDrawImageString == NULL) {
	  errMsg = dlerror();
	  goto err_dlsym;
     }
     
     funcs->XDrawString16 = (XDrawString16PtrType)dlsym(xLibHandle, "XDrawString16");
     if (funcs->XDrawString16 == NULL) {
	  errMsg = dlerror();
	  goto err_dlsym;
     } 

     
     return;
     
 err_dlsym:
     dlclose(xLibHandle);

 err_dlopen_xlib:
     fprintf(stderr,"biditext: Error: %s\n",errMsg);
     exit(1);
  /* end of code hooked from emil */
}

