/*
 * $Id: biditext_base_state.c,v 1.1.1.1 2001/09/13 12:42:16 mulix Exp $
 */
#include <string.h>
#include <unistd.h>
#include <assert.h>

#include "r2llib.h"
#include "biditext_base_state.h"
#include "file_ops.h"
#include "query_state.h"

BIDITEXT_BASE_STATE
set_biditext_base_state(const char* file_name,
			BIDITEXT_BASE_STATE requested_state)
{
     BIDITEXT_BASE_STATE bt = BT_BASE_ERROR;
     R2L_STATE st = R2L_ERROR;
     
     if (!file_name || (requested_state == BT_BASE_ERROR))
	  return BT_BASE_ERROR;

     r2l_query_state_internal(file_name, &st, &bt);
     if (bt == requested_state)
	  return requested_state;

     /* we need to set the requested biditext state, while maintaining the
	r2l state we had */
     r2l_set_state_internal(file_name, &st, &requested_state);
     return requested_state;
}

BIDITEXT_BASE_STATE
get_biditext_base_state(const char* file_name)
{
     BIDITEXT_BASE_STATE bt = BT_BASE_ERROR;

     if (!file_name)
	  return BT_BASE_ERROR;
     
     r2l_query_state_internal(file_name, NULL, &bt);
     return bt;
}
