/*
 * $Id: parse_argv.c,v 1.1.1.1 2001/09/13 12:42:16 mulix Exp $
 */
#include <string.h> 
#include <stdlib.h>
#include <assert.h>

#include "parse_argv.h"

static void 
delete_argv_members(char* argv[], int how_many_left, unsigned int how_many_to_delete)
{

     char** start = argv + how_many_to_delete;
     unsigned int index = 0;
     how_many_left -= how_many_to_delete;

     if (how_many_to_delete == 0)
	  return;
     
     while (index < how_many_left){
	  argv[index] = start[index];
	  ++index;
     }

     for ( ; how_many_to_delete > 0 ; --how_many_to_delete)
	  argv[index++] = NULL;

}

void 
parse_command_line(int* argc, char* argv[],
		   char** file_name)

{
     int numargs = 1;

     assert(file_name);

     if (!argc)
	  return;
     
     if (*argc <= 1)
	  return;
	  
     /* start parsing. look for the "--file-name" argument. */
     while(numargs < *argc)
     {
	  if (!strcmp(argv[numargs], "--r2l-file-name")){
	       if (numargs+1 < *argc){
		    *file_name = argv[numargs+1];
		    delete_argv_members(&argv[numargs], *argc - numargs, 2);
		    *argc -= 2;
	       }else {
		    delete_argv_members(&argv[numargs], *argc - numargs, 1);
		    *argc -= 1;
	       }
	       continue;
	  }
	  numargs++;
     }
}



