#ifndef R2L_STATE_H_
#define R2L_STATE_H_

#include "r2llib.h"

/** Those are lower-level functions to change the R2L state of a given file */

/** 
 * toggle the current r2l state. 
 *
 * Note that if the state was R2L_DISABLED, then the new file will
 * have a BIDITEXT_BASE_STATE of BT_BASE_NEUTRAL .
 */
R2L_STATE
toggle_r2l_state(const char* file_name);

/** 
 * set the r2l state 
 * @param file_name       The ".rev" file
 * @param requested_state The new state that file_name shoule be set to
 * @return                the new state or R2L_ERROR on invalid input
 */
R2L_STATE
set_r2l_state(const char* file_name, 
	  R2L_STATE requested_state);

/** get the current r2l state */
R2L_STATE
get_r2l_state(const char* file_name);

#endif /* R2L_STATE_H_ */
