/*
 * $Id: r2llib_data.c,v 1.1.1.1 2001/09/13 12:42:16 mulix Exp $
 */
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "r2llib.h"

struct r2llib_type{
     char* file_name;
};

r2llib_t 
create_r2llib_data(const char* file_name)
{
     r2llib_t rtl;

     if (!file_name)
	  return NULL;
     
     rtl = (r2llib_t)malloc(sizeof(struct r2llib_type));
     if (!rtl)
	  return NULL;

     memset(rtl, 0, sizeof(struct r2llib_type));

     rtl->file_name = strdup(file_name);
     if (!rtl->file_name){
	  free(rtl);
	  return NULL;
     }

     return rtl;     
}

void
destroy_r2llib_data(r2llib_t rtl)
{
     assert(rtl);

     if (rtl){
	  if (rtl->file_name)
	       free(rtl->file_name);
	  
	  free(rtl);
     }
}

char const* 
r2llib_data_get_file_name(r2llib_t rtl)
{
     if (!rtl)
	  return NULL;

     return rtl->file_name;
}
