#ifndef AUTO_DISPLAY_H
#define AUTO_DISPLAY_H

#include <string>
#include <X11/Xlib.h>

//This class is a reference-counted wrapper
//around Display

class AutoDisplay {
 public:
  //This is how you create such objects
  static AutoDisplay* getInstance(const std::string& dispName = "");

  //and this is how you release them.
  virtual void release(void) = 0;

  //I don't think you will need anything more than this
  virtual Display* getDisplay(void) = 0;
  virtual const Display* getDisplay(void) const = 0;

 private:
  AutoDisplay(const AutoDisplay& ad);
  AutoDisplay& operator = (const AutoDisplay& ad);
  
 protected:
  AutoDisplay(void);
  virtual ~AutoDisplay(void);
};


//used for comparing AutoDisplays for sets and maps
class AutoDisplayCompare {
 public:
  bool operator() (const AutoDisplay* ad1,
		   const AutoDisplay* ad2) const;
};

#endif
