#include <stdio.h>
#include <stdarg.h>
#include <syslog.h>

#include "debug.h"

void log_discard(const char* fmt, ...)
{
  /* No noise, what a relief ;-) */
}



void log_error(const char* fmt, ...)
{
  char buff[MAX_LOG_LINE];
  va_list ap;

  va_start(ap,fmt);

  vsnprintf(buff,sizeof(buff),fmt,ap);
  syslog(LOG_ERR,"%s",buff);
  
  va_end(ap);
}


void log_warning(const char* fmt, ...)
{
  char buff[MAX_LOG_LINE];
  va_list ap;

  va_start(ap,fmt);

  vsnprintf(buff,sizeof(buff),fmt,ap);
  syslog(LOG_WARNING,"%s",buff);
  
  va_end(ap);
}


void log_message(const char* fmt, ...)
{
  char buff[MAX_LOG_LINE];
  va_list ap;

  va_start(ap,fmt);

  vsnprintf(buff,sizeof(buff),fmt,ap);
  syslog(LOG_DEBUG,"%s",buff);
  
  va_end(ap); 
}
