#ifndef R2L_STATE_H
#define R2L_STATE_H

#include "r2llib.h"


/**
   r2lstate stores the current state of the R2L library.
   Any change in it causes the refresh daemon to refresh
   the affected windows
 */
struct r2lstate {
  R2L_STATE r2lState;
  BIDITEXT_BASE_STATE bidiTextBaseState;

public:
  /* Make sure the next time a refresh will take place */
  r2lstate() :
    r2lState(R2L_ERROR),
    bidiTextBaseState(BT_BASE_ERROR) {}

  //Use default copy constructor and destructor

  bool operator == (const r2lstate& other) const 
  {
    return r2lState == other.r2lState &&
      bidiTextBaseState == other.bidiTextBaseState;
  }

  bool operator != (const r2lstate& other) const
  {
    return !(*this == other);
  }
};

#endif /* R2L_STATE_H */
