#ifndef REFRESHER_H
#define REFRESHER_H


/* 
   invoked by the autorefresher thread or by the communication thread
   upon the receipt of the REFRESHD_REFRESH_NOW message
*/
void refreshNow(void);

/*
  suto-refresh thread entry point. This thread calls the   refreshNow() 
  function every REFRESH_TIME microseconds
*/
void *autoRefresher(void*);

/* 
   refresher thread entry point. The refresher thread refreshes the biditext
   enabled applications. It iterates over the Window database and checks
   if the values of the bidiTextKeys (state of the r2l library) has 
   changed. If it did, a refresh is performed on all the windows.
   An iteration is initiated either by another thread calling the
   refreshNow() function. This function is called by the communication thread
   upon the receipt of the REFRESHD_REFRESH_NOW message or periodically
   by the auto-refresh thread
 */
void* refresher(void*);


#endif /* REFRESHER_H */
