#include "window_db_iterator.h"

using namespace std;

WindowDBBidiTextKeyIterator::
WindowDBBidiTextKeyIterator() {}

WindowDBBidiTextKeyIterator::
WindowDBBidiTextKeyIterator(const WindowDB::BidiTextKeyData::iterator& it)
    : m_it(it) {}
  
string WindowDBBidiTextKeyIterator::
getBidiTextKeyName(void) const
{
  return (*m_it).first;
}
  
r2lstate WindowDBBidiTextKeyIterator::
getLastState(void) const
{
  return (*m_it).second.lastState;
}

void WindowDBBidiTextKeyIterator::
setLastState(const r2lstate& lastState)
{
  (*m_it).second.lastState = lastState;
}

r2lstate WindowDBBidiTextKeyIterator::
getCurrentState(void) const
{
  r2llib_t r2llib = (*m_it).second.r2llib;
  r2lstate state;

  r2l_query_state(r2llib,
		  &state.r2lState,
		  &state.bidiTextBaseState);

  return state;
}

bool WindowDBBidiTextKeyIterator::
operator == (const WindowDBBidiTextKeyIterator& other)
{
  return m_it == other.m_it;
}


bool WindowDBBidiTextKeyIterator::
operator != (const WindowDBBidiTextKeyIterator& other)
{
  return !(*this == other);
}


WindowDBBidiTextKeyIterator& WindowDBBidiTextKeyIterator::operator ++ (void)
{
  ++m_it;
  return *this;
}


WindowDBBidiTextKeyIterator WindowDBBidiTextKeyIterator::operator ++ (int)
{
   return WindowDBBidiTextKeyIterator(m_it++);
}
