#ifndef WINDOW_DB_ITERATOR_H
#define WINDOW_DB_ITERATOR_H

#include "window_db.h"
#include "r2lstate.h"

class WindowDBBidiTextKeyIterator {
 public:
  WindowDBBidiTextKeyIterator();
  
  std::string getBidiTextKeyName(void) const;

  r2lstate getCurrentState(void) const;

  r2lstate getLastState(void) const;
  void setLastState(const r2lstate& lastState);

  bool operator == (const WindowDBBidiTextKeyIterator& other);
  bool operator != (const WindowDBBidiTextKeyIterator& other);
  WindowDBBidiTextKeyIterator& operator ++ (void);
  WindowDBBidiTextKeyIterator operator ++ (int);
  

 private:
  WindowDBBidiTextKeyIterator(const WindowDB::BidiTextKeyData::iterator& it);

 private:
  friend class WindowDB;
  WindowDB::BidiTextKeyData::iterator m_it;
};

#endif /*WINDOW_DB_ITERATOR_H*/
