#include <iostream>
#include <string>

#include <refreshd_cnt.h>

using namespace std;

static void help(void)
{
  cout << "a[dd]  <dpyName> <windowId> <bidiTextKeyName>\n";
  cout << "r[efresh]\n";
  cout << "p[ing]\n";
  cout << "q[uit]\n";
  cout << "h[elp]\n";
  cout << flush;
}

int main()
{
  const string prompt = "testComm>";
  char cmd;
  RD_CNT_STATUS st;
  

  help();
  
  st = rdCntInitialize();
  cout << "Initialization status: " << rdCntGetErrorMessage(st) << endl;


  while (cin) {
    cout << prompt <<flush;
    cin >> cmd;

    switch(cmd) {
    case 'a':
    case 'A':
      {
	Display* dpy;
	
	string dpyName;
	Window w;
	string bidiTextKeyName;

	cin >> dpyName >> w >>  bidiTextKeyName;
	
	dpy = XOpenDisplay(dpyName.c_str());
	st = rdCntAddWindow(dpy,w,bidiTextKeyName.c_str());
	cout << "Status: " << rdCntGetErrorMessage(st) << endl;
	if (dpy != NULL)
	  XCloseDisplay(dpy);

      }
      break;
      
    case 'r':
    case 'R':
      st = rdCntRefreshNow();
      cout << "Status: " << rdCntGetErrorMessage(st) << endl;
      break;

    case 'p':
    case 'P':
      st = rdCntPingDaemon();
      cout << "Status: " << rdCntGetErrorMessage(st) << endl;
      break;

    case 'h':
    case 'H':
      help();
      break;

    case 'q':
    case 'Q':
      goto out;
      break;

    default:
      if (isspace(cmd))
	continue;

      cerr << "Illegal character " << "'" << cmd << "'" <<endl;
      break;
    }
  }

 out:
  rdCntFinalize();
  return 0;
}
